searchData={"items":[{"type":"module","title":"PhoenixAnalytics.Services.Bridge","doc":"","ref":"PhoenixAnalytics.Services.Bridge.html"},{"type":"function","title":"PhoenixAnalytics.Services.Bridge.attach_postgres/2","doc":"Attaches PostgreSQL to the DuckDB connection if the mode is set to :duck_postgres.\n\nThis function performs the following steps:\n1. Installs the PostgreSQL extension\n2. Loads the PostgreSQL extension\n3. Executes the attach_postgres query","ref":"PhoenixAnalytics.Services.Bridge.html#attach_postgres/2"},{"type":"function","title":"Parameters - PhoenixAnalytics.Services.Bridge.attach_postgres/2","doc":"- conn: The DuckDB connection","ref":"PhoenixAnalytics.Services.Bridge.html#attach_postgres/2-parameters"},{"type":"function","title":"Returns - PhoenixAnalytics.Services.Bridge.attach_postgres/2","doc":"Returns the result of the attach_postgres query.","ref":"PhoenixAnalytics.Services.Bridge.html#attach_postgres/2-returns"},{"type":"module","title":"PhoenixAnalytics.Plugs.RequestTracker","doc":"A Plug module for tracking and logging HTTP requests in a Phoenix application.\n\nThis module provides functionality to:\n- Measure the duration of each request\n- Collect relevant request data (method, path, status code, etc.)\n- Track session information\n- Asynchronously broadcast the collected data using PubSub\n\nKey components:\n\n- `call/2`: The main plug function that wraps the request, measures its duration, and manages session tracking\n- `prepare_request_data/4`: Prepares a `RequestLog` struct with relevant request and session information\n- `format_ip/1`: Formats IP addresses to string representation\n- `remote_ip/1`: Extracts the remote IP address from the connection, considering X-Forwarded-For headers\n- `get_header/3`: Safely retrieves a header value from the connection\n- `generate_uuid/0`: Generates a unique identifier for new sessions\n\nUsage:\nAdd this plug to your endpoint straight after static plugs or router to start tracking requests:\n\n    plug PhoenixAnalytics.Plugs.RequestTracker\n\nUsing it in directly in router possible as well, but than you won't be able to track static files.\n\n    pipeline :browser do\n      ...\n      plug PhoenixAnalytics.Plugs.RequestTracker\n    end\n\nNote: This module uses the `PhoenixAnalytics.Services.PubSub` module to broadcast\nrequest data, allowing for distributed apps share requests and analysis.","ref":"PhoenixAnalytics.Plugs.RequestTracker.html"},{"type":"function","title":"PhoenixAnalytics.Plugs.RequestTracker.call/2","doc":"Main plug function that wraps the request, measures its duration, and manages session tracking.\n\nThis function:\n1. Records the start time of the request.\n2. Manages session tracking by creating or retrieving a session ID and start time.\n3. Registers a before_send callback to:\n   - Calculate the request duration and session duration.\n   - Prepare request and session data.\n   - Asynchronously broadcast the data using PubSub.\n\nThe function catches any errors during data preparation or broadcasting to ensure\nthe request processing continues even if tracking fails.","ref":"PhoenixAnalytics.Plugs.RequestTracker.html#call/2"},{"type":"function","title":"Parameters - PhoenixAnalytics.Plugs.RequestTracker.call/2","doc":"- `conn`: The `Plug.Conn` struct representing the current connection.\n- `_opts`: Options passed to the plug (unused in this implementation).","ref":"PhoenixAnalytics.Plugs.RequestTracker.html#call/2-parameters"},{"type":"function","title":"Returns - PhoenixAnalytics.Plugs.RequestTracker.call/2","doc":"Returns the `conn` struct, potentially modified by subsequent plugs or handlers.","ref":"PhoenixAnalytics.Plugs.RequestTracker.html#call/2-returns"},{"type":"module","title":"PhoenixAnalytics.Entities.RequestLog","doc":"Represents a log entry for an HTTP request.\n\nThis struct contains various details about an HTTP request, including its\nunique identifier, method, path, status code, duration, and other metadata.","ref":"PhoenixAnalytics.Entities.RequestLog.html"},{"type":"type","title":"PhoenixAnalytics.Entities.RequestLog.device_type/0","doc":"Type of device_type used for the request","ref":"PhoenixAnalytics.Entities.RequestLog.html#t:device_type/0"},{"type":"type","title":"PhoenixAnalytics.Entities.RequestLog.duration_ms/0","doc":"Duration of the request in milliseconds","ref":"PhoenixAnalytics.Entities.RequestLog.html#t:duration_ms/0"},{"type":"type","title":"PhoenixAnalytics.Entities.RequestLog.inserted_at/0","doc":"Timestamp when the log entry was inserted","ref":"PhoenixAnalytics.Entities.RequestLog.html#t:inserted_at/0"},{"type":"type","title":"PhoenixAnalytics.Entities.RequestLog.method/0","doc":"HTTP method of the request","ref":"PhoenixAnalytics.Entities.RequestLog.html#t:method/0"},{"type":"type","title":"PhoenixAnalytics.Entities.RequestLog.path/0","doc":"Path of the request","ref":"PhoenixAnalytics.Entities.RequestLog.html#t:path/0"},{"type":"type","title":"PhoenixAnalytics.Entities.RequestLog.referer/0","doc":"Referer URL of the request","ref":"PhoenixAnalytics.Entities.RequestLog.html#t:referer/0"},{"type":"type","title":"PhoenixAnalytics.Entities.RequestLog.remote_ip/0","doc":"IP address of the client","ref":"PhoenixAnalytics.Entities.RequestLog.html#t:remote_ip/0"},{"type":"type","title":"PhoenixAnalytics.Entities.RequestLog.request_id/0","doc":"Unique identifier for the request","ref":"PhoenixAnalytics.Entities.RequestLog.html#t:request_id/0"},{"type":"type","title":"PhoenixAnalytics.Entities.RequestLog.session_id/0","doc":"Unique identifier for the session","ref":"PhoenixAnalytics.Entities.RequestLog.html#t:session_id/0"},{"type":"type","title":"PhoenixAnalytics.Entities.RequestLog.session_page_views/0","doc":"Number of page views in the session","ref":"PhoenixAnalytics.Entities.RequestLog.html#t:session_page_views/0"},{"type":"type","title":"PhoenixAnalytics.Entities.RequestLog.status_code/0","doc":"HTTP status code of the response","ref":"PhoenixAnalytics.Entities.RequestLog.html#t:status_code/0"},{"type":"type","title":"PhoenixAnalytics.Entities.RequestLog.t/0","doc":"","ref":"PhoenixAnalytics.Entities.RequestLog.html#t:t/0"},{"type":"type","title":"PhoenixAnalytics.Entities.RequestLog.user_agent/0","doc":"User agent string of the client","ref":"PhoenixAnalytics.Entities.RequestLog.html#t:user_agent/0"},{"type":"module","title":"PhoenixAnalytics.Web.Router","doc":"PhoenixAnalytics.Web.Router\n\nThis module provides routing functionality for the Phoenix Analytics dashboard.\n\nIt defines a macro `phoenix_analytics_dashboard` that sets up the necessary routes\nfor the analytics dashboard, and a helper function `parse_options` to process\nthe options passed to the macro.","ref":"PhoenixAnalytics.Web.Router.html"},{"type":"module","title":"Macro: phoenix_analytics_dashboard/2 - PhoenixAnalytics.Web.Router","doc":"Creates routes for the Phoenix Analytics dashboard.","ref":"PhoenixAnalytics.Web.Router.html#module-macro-phoenix_analytics_dashboard-2"},{"type":"module","title":"Parameters: - PhoenixAnalytics.Web.Router","doc":"- path: The base path for the dashboard routes.\n  - opts: Optional keyword list of configuration options.","ref":"PhoenixAnalytics.Web.Router.html#module-parameters"},{"type":"module","title":"Options: - PhoenixAnalytics.Web.Router","doc":"- :as - The name for the live session (default: :phoenix_analytics_dashboard)\n  - :on_mount - Additional mount hooks to be executed (default: [])","ref":"PhoenixAnalytics.Web.Router.html#module-options"},{"type":"module","title":"Usage: - PhoenixAnalytics.Web.Router","doc":"```elixir\nphoenix_analytics_dashboard \"/analytics\"\n```","ref":"PhoenixAnalytics.Web.Router.html#module-usage"},{"type":"module","title":"Function: parse_options/2 - PhoenixAnalytics.Web.Router","doc":"Processes the options passed to the `phoenix_analytics_dashboard` macro.","ref":"PhoenixAnalytics.Web.Router.html#module-function-parse_options-2"},{"type":"module","title":"Parameters: - PhoenixAnalytics.Web.Router","doc":"- opts: The options keyword list.\n  - path: The base path for the dashboard.","ref":"PhoenixAnalytics.Web.Router.html#module-parameters"},{"type":"module","title":"Returns: - PhoenixAnalytics.Web.Router","doc":"A tuple containing the session name and session options.\n\nThis function sets up the default on_mount hooks, including a custom hook to set\nthe dashboard path, and allows for additional custom hooks to be added.\nIt also configures the root layout for the dashboard.","ref":"PhoenixAnalytics.Web.Router.html#module-returns"},{"type":"macro","title":"PhoenixAnalytics.Web.Router.phoenix_analytics_dashboard/2","doc":"","ref":"PhoenixAnalytics.Web.Router.html#phoenix_analytics_dashboard/2"},{"type":"module","title":"PhoenixAnalytics.Services.Batcher","doc":"A GenServer module for batching and inserting RequestLog entries into the database.\n\nThis module provides functionality to efficiently insert RequestLog entries by batching them\nand inserting them in bulk. It uses a GenServer to manage the state of the batch and\nperiodically flush the batch to the database.\n\nThe batch is processed and inserted into the database either when it reaches 1_000 logs\nor after 1 second, whichever comes first.","ref":"PhoenixAnalytics.Services.Batcher.html"},{"type":"module","title":"Usage - PhoenixAnalytics.Services.Batcher","doc":"To insert a RequestLog:\n\n    PhoenixAnalytics.Services.Batcher.insert(%PhoenixAnalytics.Entities.RequestLog{})\n\nAlternatively, you can send an event to PubSub for request_log insertion:\n\n    PhoenixAnalytics.Services.PubSub.broadcast(:request_sent, %PhoenixAnalytics.Entities.RequestLog{})\n\nThe module will handle batching and inserting the logs automatically.\nThis approach allows for handling distributed app scenarios.","ref":"PhoenixAnalytics.Services.Batcher.html#module-usage"},{"type":"function","title":"PhoenixAnalytics.Services.Batcher.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"PhoenixAnalytics.Services.Batcher.html#child_spec/1"},{"type":"function","title":"PhoenixAnalytics.Services.Batcher.insert/1","doc":"Inserts a RequestLog into the batch queue.\nThe batch is processed and inserted into the database either when it reaches 1_000 logs or after 1 second, whichever comes first.","ref":"PhoenixAnalytics.Services.Batcher.html#insert/1"},{"type":"function","title":"Parameters - PhoenixAnalytics.Services.Batcher.insert/1","doc":"- request_log: A PhoenixAnalytics.Entities.RequestLog struct to be inserted.","ref":"PhoenixAnalytics.Services.Batcher.html#insert/1-parameters"},{"type":"function","title":"Examples - PhoenixAnalytics.Services.Batcher.insert/1","doc":"iex> PhoenixAnalytics.Services.Batcher.insert(%PhoenixAnalytics.Entities.RequestLog{})\n\nNote: You can also use PubSub to insert a RequestLog, which is useful for distributed app scenarios:\n\n    iex> PhoenixAnalytics.Services.PubSub.broadcast(:request_sent, %PhoenixAnalytics.Entities.RequestLog{})","ref":"PhoenixAnalytics.Services.Batcher.html#insert/1-examples"},{"type":"function","title":"PhoenixAnalytics.Services.Batcher.send_batch/1","doc":"Sends a batch of RequestLogs to be inserted into the database.","ref":"PhoenixAnalytics.Services.Batcher.html#send_batch/1"},{"type":"function","title":"Parameters - PhoenixAnalytics.Services.Batcher.send_batch/1","doc":"- batch: A list of PhoenixAnalytics.Entities.RequestLog structs to be inserted.","ref":"PhoenixAnalytics.Services.Batcher.html#send_batch/1-parameters"},{"type":"function","title":"Examples - PhoenixAnalytics.Services.Batcher.send_batch/1","doc":"iex> PhoenixAnalytics.Services.Batcher.send_batch([%PhoenixAnalytics.Entities.RequestLog{}, %PhoenixAnalytics.Entities.RequestLog{}])","ref":"PhoenixAnalytics.Services.Batcher.html#send_batch/1-examples"},{"type":"module","title":"PhoenixAnalytics.Services.Cache","doc":"This module provides caching functionality for PhoenixAnalytics.\n\n  The main purpose of this cache is to reduce the number of read calls to DuckDB.\n  DuckDB is designed for running large queries infrequently, rather than small\n  queries often. By caching results, we can improve performance and reduce the\n  load on the database for frequently accessed data.\n\n  The cache uses Cachex with a default TTL (Time To Live) of 2 minutes.","ref":"PhoenixAnalytics.Services.Cache.html"},{"type":"function","title":"PhoenixAnalytics.Services.Cache.add/2","doc":"Adds a value to the cache with the given key.","ref":"PhoenixAnalytics.Services.Cache.html#add/2"},{"type":"function","title":"Parameters - PhoenixAnalytics.Services.Cache.add/2","doc":"* `key` - The key under which to store the value in the cache.\n  * `value` - The value to be stored in the cache.","ref":"PhoenixAnalytics.Services.Cache.html#add/2-parameters"},{"type":"function","title":"Returns - PhoenixAnalytics.Services.Cache.add/2","doc":"* `{:ok, true}` - If the value was successfully added to the cache.\n  * `{:ok, :error}` - If there was an error adding the value to the cache.","ref":"PhoenixAnalytics.Services.Cache.html#add/2-returns"},{"type":"function","title":"Examples - PhoenixAnalytics.Services.Cache.add/2","doc":"iex> PhoenixAnalytics.Services.Cache.add(\"new_key\", \"new_value\")\n    {:ok, true}\n\n    iex> PhoenixAnalytics.Services.Cache.add(\"existing_key\", \"updated_value\")\n    {:ok, true}","ref":"PhoenixAnalytics.Services.Cache.html#add/2-examples"},{"type":"function","title":"PhoenixAnalytics.Services.Cache.fetch/2","doc":"Fetches a value from the cache for the given key, or computes and caches it if not present.","ref":"PhoenixAnalytics.Services.Cache.html#fetch/2"},{"type":"function","title":"Parameters - PhoenixAnalytics.Services.Cache.fetch/2","doc":"* `key` - The key to fetch from the cache.\n  * `callback` - A function that computes the value if it's not in the cache.","ref":"PhoenixAnalytics.Services.Cache.html#fetch/2-parameters"},{"type":"function","title":"Returns - PhoenixAnalytics.Services.Cache.fetch/2","doc":"* `{:ok, value}` - If the value was found in the cache.\n\n    * `{:commit, value}` - If the value was successfully computed and cached.\n\n    * `{:error, reason}` - If there was an error fetching or computing the value.","ref":"PhoenixAnalytics.Services.Cache.html#fetch/2-returns"},{"type":"function","title":"Examples - PhoenixAnalytics.Services.Cache.fetch/2","doc":"iex> PhoenixAnalytics.Services.Cache.fetch(\"some_key\", fn -> \"computed_value\" end)\n    {:commit, \"computed_value\"}\n\n    iex> PhoenixAnalytics.Services.Cache.fetch(\"existing_key\", fn -> \"new_value\" end)\n    {:ok, \"cached_value\"}","ref":"PhoenixAnalytics.Services.Cache.html#fetch/2-examples"},{"type":"function","title":"PhoenixAnalytics.Services.Cache.get/1","doc":"Retrieves a value from the cache for the given key.","ref":"PhoenixAnalytics.Services.Cache.html#get/1"},{"type":"function","title":"Returns - PhoenixAnalytics.Services.Cache.get/1","doc":"* `{:ok, nil}` - If the key is not found in the cache.\n  * `{:ok, value}` - If the key is found, where `value` is the cached data.","ref":"PhoenixAnalytics.Services.Cache.html#get/1-returns"},{"type":"function","title":"Examples - PhoenixAnalytics.Services.Cache.get/1","doc":"iex> PhoenixAnalytics.Services.Cache.get(\"some_key\")\n    {:ok, nil}\n\n    iex> PhoenixAnalytics.Services.Cache.get(\"existing_key\")\n    {:ok, \"cached_value\"}","ref":"PhoenixAnalytics.Services.Cache.html#get/1-examples"},{"type":"module","title":"PhoenixAnalytics.Services.PubSub","doc":"A module for handling PubSub operations in Phoenix Analytics.\n\nThis module provides a robust and efficient interface for subscribing to and broadcasting\nevents related to request analytics. It leverages Phoenix.PubSub under the hood\nto manage pub/sub functionality, enabling seamless communication across distributed\nsystems and allowing for load-balanced application sharing of requests.","ref":"PhoenixAnalytics.Services.PubSub.html"},{"type":"function","title":"PhoenixAnalytics.Services.PubSub.broadcast/1","doc":"Broadcasts an event to all subscribers of the request topic.\n\nThis function sends the provided event to all processes that have subscribed to the request topic.\nIt's typically used to distribute information about new requests.\n\nIn case of Postgres backend local broadcast is used to avoid any data duplication across nodes.","ref":"PhoenixAnalytics.Services.PubSub.html#broadcast/1"},{"type":"function","title":"Parameters - PhoenixAnalytics.Services.PubSub.broadcast/1","doc":"- event: A `PhoenixAnalytics.Entities.RequestLog` struct representing the event to be broadcasted.","ref":"PhoenixAnalytics.Services.PubSub.html#broadcast/1-parameters"},{"type":"function","title":"Examples - PhoenixAnalytics.Services.PubSub.broadcast/1","doc":"iex> request_log = %PhoenixAnalytics.Entities.RequestLog{request_id: \"123\", path: \"/api/users\"}\n    iex> PhoenixAnalytics.Services.PubSub.broadcast(request_log)\n    :ok","ref":"PhoenixAnalytics.Services.PubSub.html#broadcast/1-examples"},{"type":"function","title":"Return Value - PhoenixAnalytics.Services.PubSub.broadcast/1","doc":"Returns `:ok` if the broadcast is successful.","ref":"PhoenixAnalytics.Services.PubSub.html#broadcast/1-return-value"},{"type":"function","title":"Errors - PhoenixAnalytics.Services.PubSub.broadcast/1","doc":"May return `{:error, term()}` if there's an issue with broadcasting the message.","ref":"PhoenixAnalytics.Services.PubSub.html#broadcast/1-errors"},{"type":"function","title":"PhoenixAnalytics.Services.PubSub.name/0","doc":"Returns the name of the PubSub server.\n\nThis function provides the atom used to identify the PubSub server. It's useful\nwhen you need to reference the PubSub server in other parts of your application.","ref":"PhoenixAnalytics.Services.PubSub.html#name/0"},{"type":"function","title":"Examples - PhoenixAnalytics.Services.PubSub.name/0","doc":"iex> PhoenixAnalytics.Services.PubSub.name()\n    :pa_pubsub","ref":"PhoenixAnalytics.Services.PubSub.html#name/0-examples"},{"type":"function","title":"Return Value - PhoenixAnalytics.Services.PubSub.name/0","doc":"Returns the atom `:pa_pubsub`.","ref":"PhoenixAnalytics.Services.PubSub.html#name/0-return-value"},{"type":"function","title":"PhoenixAnalytics.Services.PubSub.subscribe/0","doc":"Subscribes the current process to the request topic.\n\nThis function allows a process to receive messages broadcasted to the request topic.\nAfter subscribing, the process will receive tuples of the form `{:request_sent, event}`\nwhenever a new event is broadcasted.","ref":"PhoenixAnalytics.Services.PubSub.html#subscribe/0"},{"type":"function","title":"Examples - PhoenixAnalytics.Services.PubSub.subscribe/0","doc":"iex> PhoenixAnalytics.Services.PubSub.subscribe()\n    :ok","ref":"PhoenixAnalytics.Services.PubSub.html#subscribe/0-examples"},{"type":"function","title":"Return Value - PhoenixAnalytics.Services.PubSub.subscribe/0","doc":"Returns `:ok` if the subscription is successful.","ref":"PhoenixAnalytics.Services.PubSub.html#subscribe/0-return-value"},{"type":"function","title":"Errors - PhoenixAnalytics.Services.PubSub.subscribe/0","doc":"May raise an error if the PubSub server is not available or if there's an issue with the subscription.","ref":"PhoenixAnalytics.Services.PubSub.html#subscribe/0-errors"},{"type":"module","title":"PhoenixAnalytics.Services.Telemetry","doc":"","ref":"PhoenixAnalytics.Services.Telemetry.html"},{"type":"function","title":"PhoenixAnalytics.Services.Telemetry.log_error/2","doc":"","ref":"PhoenixAnalytics.Services.Telemetry.html#log_error/2"},{"type":"function","title":"PhoenixAnalytics.Services.Telemetry.log_success/1","doc":"","ref":"PhoenixAnalytics.Services.Telemetry.html#log_success/1"},{"type":"module","title":"PhoenixAnalytics.Services.Utility","doc":"A helper module containing static utility functions for Phoenix Analytics.\n\nThis module provides various utility functions that are used across the\nPhoenix Analytics application. It includes functions for timestamp generation\nand device type detection based on user agent strings.","ref":"PhoenixAnalytics.Services.Utility.html"},{"type":"function","title":"PhoenixAnalytics.Services.Utility.get_device_type/1","doc":"Determines the device type based on the user agent string.\n\nThis function provides a simple and fast way to categorize devices as mobile,\ntablet, or desktop based on the user agent string. It was implemented as a\nlightweight alternative to ua_parser and ua_inspector, which were found to be\nexcessively slow for this use case.\n\nWhile this method is not as comprehensive as full-fledged user agent parsing\nlibraries, it offers a quick classification that is sufficient for many\nanalytics purposes.","ref":"PhoenixAnalytics.Services.Utility.html#get_device_type/1"},{"type":"function","title":"Parameters - PhoenixAnalytics.Services.Utility.get_device_type/1","doc":"* agent_string - The user agent string to analyze","ref":"PhoenixAnalytics.Services.Utility.html#get_device_type/1-parameters"},{"type":"function","title":"Returns - PhoenixAnalytics.Services.Utility.get_device_type/1","doc":"A string indicating the device type:\n  * \"mobile\" for mobile devices\n  * \"tablet\" for tablet devices\n  * \"desktop\" for desktop devices or any unrecognized device type","ref":"PhoenixAnalytics.Services.Utility.html#get_device_type/1-returns"},{"type":"function","title":"Examples - PhoenixAnalytics.Services.Utility.get_device_type/1","doc":"iex> PhoenixAnalytics.Services.Utility.get_device_type(\"Mozilla/5.0 (iPhone; CPU iPhone OS 14_4 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/14.0.3 Mobile/15E148 Safari/604.1\")\n    \"mobile\"\n\n    iex> PhoenixAnalytics.Services.Utility.get_device_type(\"Mozilla/5.0 (iPad; CPU OS 14_4 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/14.0 Mobile/15E148 Safari/604.1\")\n    \"tablet\"\n\n    iex> PhoenixAnalytics.Services.Utility.get_device_type(\"Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/91.0.4472.124 Safari/537.36\")\n    \"desktop\"","ref":"PhoenixAnalytics.Services.Utility.html#get_device_type/1-examples"},{"type":"function","title":"PhoenixAnalytics.Services.Utility.inserted_at/0","doc":"Returns the current UTC timestamp in DuckDB format.\n\nThis function generates a timestamp string that is compatible with DuckDB's\nTIMESTAMP data type. The timestamp is in UTC and includes millisecond precision.","ref":"PhoenixAnalytics.Services.Utility.html#inserted_at/0"},{"type":"function","title":"Examples - PhoenixAnalytics.Services.Utility.inserted_at/0","doc":"iex> PhoenixAnalytics.Services.Utility.inserted_at()\n    \"2023-05-15 14:30:45.123\"\n\nReturns a string in the format \"YYYY-MM-DD HH:MM:SS.mmm\".","ref":"PhoenixAnalytics.Services.Utility.html#inserted_at/0-examples"},{"type":"function","title":"PhoenixAnalytics.Services.Utility.mode/0","doc":"Determines the current mode of operation based on database configurations.\n\nThis function checks the application environment for DuckDB and PostgreSQL\nconfigurations to determine the current mode of operation.","ref":"PhoenixAnalytics.Services.Utility.html#mode/0"},{"type":"function","title":"Returns - PhoenixAnalytics.Services.Utility.mode/0","doc":"An atom indicating the mode:\n  * `:duck_only` if only DuckDB is configured\n  * `:duck_postgres` if both DuckDB and PostgreSQL are configured\n  * `:duck_only` as a fallback if no valid configuration is found","ref":"PhoenixAnalytics.Services.Utility.html#mode/0-returns"},{"type":"function","title":"Examples - PhoenixAnalytics.Services.Utility.mode/0","doc":"iex> PhoenixAnalytics.Services.Utility.mode()\n    :duck_only","ref":"PhoenixAnalytics.Services.Utility.html#mode/0-examples"},{"type":"function","title":"PhoenixAnalytics.Services.Utility.uuid/0","doc":"Generates a new UUID (Universally Unique Identifier).\n\nThis function creates a version 4 UUID, which is randomly generated.","ref":"PhoenixAnalytics.Services.Utility.html#uuid/0"},{"type":"function","title":"Examples - PhoenixAnalytics.Services.Utility.uuid/0","doc":"iex> PhoenixAnalytics.Services.Utility.uuid()\n    \"550e8400-e29b-41d4-a716-446655440000\"\n\nReturns a string representation of the UUID.","ref":"PhoenixAnalytics.Services.Utility.html#uuid/0-examples"},{"type":"module","title":"PhoenixAnalytics.Repo","doc":"A custom repository module for the PhoenixAnalytics project.\n\nThis module maintains write and read connections to a DuckDB database using GenServer,\nand provides functions to execute queries, insert data, and manage the connection.\n\nThe repository handles both safe (parameterized) and unsafe query execution,\nas well as batch inserts using the DuckDB appender.\n\nThe database connections are stored in the GenServer state and can be accessed\nusing the `get_connection/0` or `get_read_connection/0` functions.","ref":"PhoenixAnalytics.Repo.html"},{"type":"function","title":"PhoenixAnalytics.Repo.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"PhoenixAnalytics.Repo.html#child_spec/1"},{"type":"function","title":"PhoenixAnalytics.Repo.execute_fetch/1","doc":"Executes a safe (parameterized) query on the DuckDB connection and fetches all results.\n\nThis function retrieves the database connection, prepares a statement with the given query,\nexecutes it with the provided parameters, and fetches all results.","ref":"PhoenixAnalytics.Repo.html#execute_fetch/1"},{"type":"function","title":"Parameters - PhoenixAnalytics.Repo.execute_fetch/1","doc":"* `{query, params}` - A tuple containing the SQL query string and a list of parameters.","ref":"PhoenixAnalytics.Repo.html#execute_fetch/1-parameters"},{"type":"function","title":"Returns - PhoenixAnalytics.Repo.execute_fetch/1","doc":"* `results` - If the query is successfully executed and results are fetched.\n  * `{:error, reason}` - If there's an error retrieving the connection, executing the query, or fetching results.","ref":"PhoenixAnalytics.Repo.html#execute_fetch/1-returns"},{"type":"function","title":"Examples - PhoenixAnalytics.Repo.execute_fetch/1","doc":"iex> PhoenixAnalytics.Repo.execute_fetch({\"SELECT * FROM users WHERE age > ?\", [25]})\n    [%{\"name\" => \"John\", \"age\" => 30}, %{\"name\" => \"Jane\", \"age\" => 28}]","ref":"PhoenixAnalytics.Repo.html#execute_fetch/1-examples"},{"type":"function","title":"PhoenixAnalytics.Repo.execute_safe/1","doc":"Executes a safe (parameterized) query on the DuckDB connection.\n\nThis function retrieves the database connection, prepares a statement with the given query,\nand executes it with the provided parameters. This method is preferred over `execute_unsafe/1`\nas it helps prevent SQL injection attacks.","ref":"PhoenixAnalytics.Repo.html#execute_safe/1"},{"type":"function","title":"Parameters - PhoenixAnalytics.Repo.execute_safe/1","doc":"* `{query, params}` - A tuple containing the SQL query string and a list of parameters.","ref":"PhoenixAnalytics.Repo.html#execute_safe/1-parameters"},{"type":"function","title":"Returns - PhoenixAnalytics.Repo.execute_safe/1","doc":"* `{:ok, result}` - If the query is successfully executed.\n  * `{:error, reason}` - If there's an error retrieving the connection or executing the query.","ref":"PhoenixAnalytics.Repo.html#execute_safe/1-returns"},{"type":"function","title":"Examples - PhoenixAnalytics.Repo.execute_safe/1","doc":"iex> PhoenixAnalytics.Repo.execute_safe({\"SELECT * FROM users WHERE id = ?\", [1]})\n    {:ok, %Duckdbex.Result{}}","ref":"PhoenixAnalytics.Repo.html#execute_safe/1-examples"},{"type":"function","title":"PhoenixAnalytics.Repo.execute_unsafe/1","doc":"Executes an unsafe query on the DuckDB connection.\n\nThis function retrieves the database connection and executes the given query\nwithout any parameter binding. It should be used with caution, as it may be\nvulnerable to SQL injection if used with user-supplied input.","ref":"PhoenixAnalytics.Repo.html#execute_unsafe/1"},{"type":"function","title":"Parameters - PhoenixAnalytics.Repo.execute_unsafe/1","doc":"* `query` - A string containing the SQL query to be executed.","ref":"PhoenixAnalytics.Repo.html#execute_unsafe/1-parameters"},{"type":"function","title":"Returns - PhoenixAnalytics.Repo.execute_unsafe/1","doc":"* `{:ok, result}` - If the query is successfully executed.\n  * `{:error, reason}` - If there's an error retrieving the connection or executing the query.","ref":"PhoenixAnalytics.Repo.html#execute_unsafe/1-returns"},{"type":"function","title":"Examples - PhoenixAnalytics.Repo.execute_unsafe/1","doc":"iex> PhoenixAnalytics.Repo.execute_unsafe(\"SELECT * FROM users\")\n    {:ok, %Duckdbex.Result{}}","ref":"PhoenixAnalytics.Repo.html#execute_unsafe/1-examples"},{"type":"function","title":"PhoenixAnalytics.Repo.get_connection/0","doc":"Retrieves the current DuckDB connection from the GenServer state.\n\nThis function sends a synchronous call to the GenServer to get the current\ndatabase connection stored in its state.","ref":"PhoenixAnalytics.Repo.html#get_connection/0"},{"type":"function","title":"Returns - PhoenixAnalytics.Repo.get_connection/0","doc":"* `{:ok, connection}` - If the connection is successfully retrieved.\n  * `{:error, reason}` - If there's an error retrieving the connection.","ref":"PhoenixAnalytics.Repo.html#get_connection/0-returns"},{"type":"function","title":"Examples - PhoenixAnalytics.Repo.get_connection/0","doc":"iex> PhoenixAnalytics.Repo.get_connection()\n    {:ok, %Duckdbex.Connection{}}","ref":"PhoenixAnalytics.Repo.html#get_connection/0-examples"},{"type":"function","title":"PhoenixAnalytics.Repo.get_read_connection/0","doc":"Creates and returns a new DuckDB read connection.\n\nThis function opens a new connection to the DuckDB database for read operations,\nallowing for increased read throughput by not relying on the GenServer state.","ref":"PhoenixAnalytics.Repo.html#get_read_connection/0"},{"type":"function","title":"Returns - PhoenixAnalytics.Repo.get_read_connection/0","doc":"* `{:ok, connection}` - If a new connection is successfully created.\n  * `{:error, reason}` - If there's an error creating the connection.","ref":"PhoenixAnalytics.Repo.html#get_read_connection/0-returns"},{"type":"function","title":"Examples - PhoenixAnalytics.Repo.get_read_connection/0","doc":"iex> PhoenixAnalytics.Repo.get_read_connection()\n    {:ok, %Duckdbex.Connection{}}","ref":"PhoenixAnalytics.Repo.html#get_read_connection/0-examples"},{"type":"function","title":"PhoenixAnalytics.Repo.init/1","doc":"Initializes the GenServer state with a DuckDB connection.\n\nThis function opens a DuckDB database connection using the path specified in the\napplication configuration. If the connection is successfully established, it\nreturns the initial state with the connection.","ref":"PhoenixAnalytics.Repo.html#init/1"},{"type":"function","title":"Returns - PhoenixAnalytics.Repo.init/1","doc":"* `{:ok, state}` - If the database connection is successfully established.\n  * `{:stop, reason}` - If there's an error opening the database or creating a connection.","ref":"PhoenixAnalytics.Repo.html#init/1-returns"},{"type":"function","title":"Notes - PhoenixAnalytics.Repo.init/1","doc":"* If `@db_path` is `nil`, the application will fail to start. Ensure that a valid\n    database path is configured in the application environment.","ref":"PhoenixAnalytics.Repo.html#init/1-notes"},{"type":"function","title":"PhoenixAnalytics.Repo.insert_many/1","doc":"Inserts multiple RequestLog entries into the database using the DuckDB appender.\n\nThis function retrieves the database connection, creates an appender for the specified table,\nand adds multiple RequestLog entries to the table in a batch operation. This method is more efficient\nfor inserting large amounts of data compared to individual inserts.","ref":"PhoenixAnalytics.Repo.html#insert_many/1"},{"type":"function","title":"Parameters - PhoenixAnalytics.Repo.insert_many/1","doc":"* `batch` - A list of RequestLog.t() to be inserted into the table.","ref":"PhoenixAnalytics.Repo.html#insert_many/1-parameters"},{"type":"function","title":"Returns - PhoenixAnalytics.Repo.insert_many/1","doc":"* `{:ok, result}` - If the batch insert is successful.\n  * `{:error, reason}` - If there's an error retrieving the connection or performing the batch insert.","ref":"PhoenixAnalytics.Repo.html#insert_many/1-returns"},{"type":"function","title":"Examples - PhoenixAnalytics.Repo.insert_many/1","doc":"iex> batch = [%RequestLog{method: \"GET\", path: \"/home\"}, %RequestLog{method: \"POST\", path: \"/api\"}]\n    iex> PhoenixAnalytics.Repo.insert_many(batch)\n    :ok\n\nFor performance testing, you can run `../priv/repo/seeds.exs` locally.","ref":"PhoenixAnalytics.Repo.html#insert_many/1-examples"},{"type":"extras","title":"📊 Phoenix Analytics","doc":"# 📊 Phoenix Analytics\n\n \n     \n     \n     \n \n\n![](https://raw.githubusercontent.com/lalabuy948/PhoenixAnalytics/master/github/hero.png)\n\n![](https://raw.githubusercontent.com/lalabuy948/PhoenixAnalytics/master/github/screenshot.png)\n\nPhoenix Analytics is embedded plug and play tool designed for Phoenix applications. It provides a simple and efficient way to track and analyze user behavior and application performance without impacting your main application's performance and database.\n\nKey features:\n- ⚡️ Lightweight and fast analytics tracking\n- ⛓️‍💥 Separate storage using DuckDB to avoid affecting your main database\n- 🔌 Easy integration with Phoenix applications\n- 📊 Minimalistic dashboard for data visualization\n\n> The decision to use [DuckDB](https://duckdb.org) as the storage was made to ensure that the analytics data collection process does not interfere with or degrade the performance of your application's primary transactional database. This separation allows for efficient data storage and querying specifically optimized for analytics purposes, while keeping your main database focused on serving your application's core functionality.\n\n\nhttps://github.com/user-attachments/assets/66ee00d4-3928-46ec-bfca-c03e2569bc0a","ref":"readme.html"},{"type":"extras","title":"Installation - 📊 Phoenix Analytics","doc":"If [available in Hex](https://hex.pm/packages/phoenix_analytics), the package can be installed\nby adding `phoenix_analytics` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:phoenix_analytics, \"~> 0.3\"}\n  ]\nend\n```\n\nUpdate `config/config.exs`\n\n```elixir\nconfig :phoenix_analytics,\n  duckdb_path: System.get_env(\"DUCKDB_PATH\") || \"analytics.duckdb\",\n  app_domain: System.get_env(\"PHX_HOST\") || \"example.com\"\n```\n\n> [!IMPORTANT]\n> In case you have dynamic cluster, you can use your PostgresDB as backend.\n\n```elixir\nconfig :phoenix_analytics,\n  duckdb_path: System.get_env(\"DUCKDB_PATH\") || \"analytics.duckdb\",\n  app_domain: System.get_env(\"PHX_HOST\") || \"example.com\",\n  postgres_conn: System.get_env(\"POSTGRES_CONN\") || \"dbname=postgres user=phoenix password=analytics host=localhost\"\n```\n\n> [!IMPORTANT]\n> In case you would like to proceed with Postgres option, consider enabling caching.\n\n```elixir\nconfig :phoenix_analytics,\n  duckdb_path: System.get_env(\"DUCKDB_PATH\") || \"analytics.duckdb\",\n  app_domain: System.get_env(\"PHX_HOST\") || \"example.com\",\n  postgres_conn: System.get_env(\"POSTGRES_CONN\") || \"dbname=postgres user=phoenix password=analytics host=localhost\",\n  cache_ttl: System.get_env(\"CACHE_TTL\") || 120 # seconds\n```\n\n> [!IMPORTANT]\n> In case you are hosting your app on fly.io or heroku which doesn't let to persist data on the disk,\n> you can add `in_memory: true` into :phoenix_analytics config.\n> And don't forget to remove `duckdb_path` from the config, otherwise PA will try to create duckdb on the disk.\n\n```elixir\nconfig :phoenix_analytics,\n  app_domain: System.get_env(\"PHX_HOST\") || \"example.com\",\n  postgres_conn: System.get_env(\"POSTGRES_CONN\") || \"dbname=postgres user=phoenix password=analytics host=localhost\",\n  in_memory: true\n```\n\nAdd migration file\n\n> In case you have ecto less / no migrations project you can do the following:\n\n> `iex -S mix` `PhoenixAnalytics.Migration.up()`\n\n```sh\nmix ecto.gen.migration add_phoenix_analytics\n```\n\n> [!TIP]\n> Based on your configuration migration will be run in appropriate database.\n> If only `duckdb_path` then in duckdb file.\n> If `duckdb_path` and `postgres_conn` provided then in your Postgres database.\n\n```elixir\ndefmodule MyApp.Repo.Migrations.AddPhoenixAnalytics do\n  use Ecto.Migration\n\n  def up, do: PhoenixAnalytics.Migration.up()\n  def down, do: PhoenixAnalytics.Migration.down()\nend\n```\n\n```sh\nmix ecto.migrate\n```\n\nAdd plug to enable tracking to `endpoint.ex`, ‼️ add it straight after your `Plug.Static`\n\n```elixir\nplug PhoenixAnalytics.Plugs.RequestTracker\n```\n\nAdd dashboard route to your `router.ex`\n\n```elixir\nuse PhoenixAnalytics.Web, :router\n\nphoenix_analytics_dashboard \"/analytics\"\n```\n\nUpdate your `.gitignore`\n\n```.gitignore\n*.duckdb\n*.duckdb.*\n```\n\n> [!WARNING]\n> ‼️ Please test thoroughly before proceeding to production!","ref":"readme.html#installation"},{"type":"extras","title":"Documentation - 📊 Phoenix Analytics","doc":"Documentation can be generated with [ExDoc](https://github.com/elixir-lang/ex_doc)\nand published on [HexDocs](https://hexdocs.pm/phoenix_analytics). Once published, the docs can\nbe found at  .\n\nShortcuts:\n\n- `t` -> today\n- `ctrl+t` -> yesterday\n- `w` -> last_week\n- `m` -> last_30_days\n- `q` -> last_90_days\n- `y` -> last_12_month\n- `ctrl+w` -> previous_week\n- `ctrl+m` -> previous_month\n- `ctrl+q` -> previous_quarter\n- `ctrl+y` -> previous_year\n- `a` -> all_time","ref":"readme.html#documentation"},{"type":"extras","title":"Development - 📊 Phoenix Analytics","doc":"If you would like to contribute, first you would need to install deps, assets and then compile css and js.\nI put everything under next mix command:\n\n```sh\nmix setup\n```\n\nThen you would need some database with seeds. Here is command for this:\n\n```sh\nDUCKDB_PATH=\"analytics.duckdb\" mix run priv/repo/seeds.exs\n```\n\nor if you would like to test with Postgres backend:\n\n```sh\ncd examples/duck_postgres/\n\ndocker compose -f postgres-compose.yml up\n\n# from project root\nmix run priv/repo/seeds_postgres.exs\n```\n\n> [!NOTE]\n> Move database with seeds to example project which you going to use.\n\nLastly you can use one of example applications to start server.\n\n```sh\ncd examples/duck_only/\n\nmix deps.get\n\nmix phx.server\n```\n\nYou can navigate to `http://localhost:4000/dev/analytics`","ref":"readme.html#development"},{"type":"extras","title":"Performance test - 📊 Phoenix Analytics","doc":"I performed [vegeta](https://github.com/tsenart/vegeta) test on basic Macbook Air M2, to see if plug will affect application performance.\nScript can be found here: `vegeta/vegeta.sh`\n\n| With plug              | Without                |\n| ---------------------- | ---------------------- |\n| ![with](/github/vegeta-with.png) | ![without](/github/vegeta-without.png) |","ref":"readme.html#performance-test"},{"type":"extras","title":"For whom this library - 📊 Phoenix Analytics","doc":"- [x] Single instance Phoenix app (duckdb only recommended)\n- [x] Multiple instances of Phoenix app **without** auto scaling group (duckdb or postgres option can be used)\n- [x] Multiple instances of Phoenix app **with** auto scaling group (only postgres powered apps supported at the moment)","ref":"readme.html#for-whom-this-library"},{"type":"extras","title":"Heavily inspired by - 📊 Phoenix Analytics","doc":"- [error-tracker](https://github.com/elixir-error-tracker/error-tracker)\n- [plausible.io](https://plausible.io)","ref":"readme.html#heavily-inspired-by"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}